@ECHO off
REM W. Dwyne 2016
color 70
rem To avoid the problems DATE - Get the system date from WMI - in international format.
rem
for /f %%a in ('wmic os get LocalDateTime ^| findstr ^[0-9]') do (set systim=%%a)
rem 
set mydate=%systim:~0,4%-%systim:~4,2%-%systim:~6,2%
ECHO.
ECHO      This Batch File will will create a theme folder 
ECHO             and assemble the required files. (%mydate%)
ECHO.

REM Promp for the type S for Standard P for Panoramic
ECHO.
ECHO.  Create a Standard (S) or Panoramic (P) theme or Both combined (B)?
ECHO.
SET /P type=Enter the THEME type (S or P or B)?
IF %type% EQU s SET type=S
IF %type% EQU p SET type=P
If %type% EQU b SET type=B
IF %type% EQU S GOTO TYPEOK
IF %type% EQU P GOTO TYPEOK
IF %type% EQU B GOTO TYPEOK

ECHO.
ECHO.  Type incorrect must be S or P or B Not %TYPE%
ECHO.
PAUSE
GOTO DONE

:TYPEOK
REM copycmd should be %xcopy% or %ECHO% for testing
SET copycmd=xcopy
REM SET copycmd=ECHO
REM IF %copycmd% EQU ECHO ECHO. 		Note: In test mode FILES will not be copied!
SET both=N
IF %type% EQU B SET type=S& SET both=B& ECHO. We will add the Standard files first.
REM     Note:        The S& is not a mistake as S & results in variable being set to Sspace
IF %type% EQU S SET typename=Standard & SET filename=Standard
IF %type% EQU P SET typename=Panoramic & SET filename=Panoramic
IF %both% EQU B SET filename=Combined

REM Get the current folder name 
SET current_folder=%cd%

REM Set the batch file name
SET batch_name=Build Theme.bat

REM Set the theme folder name
SET theme_dir_name1=%TYPE%1000-Personal-Pictures
SET /A theme1_ok=0
SET theme_dir_name2=%TYPE%2000-Personal-Scenes
SET /A theme2_ok=0
SET theme_dir_name3=%TYPE%3000-Animals
SET /A theme3_ok=0
SET theme_dir_name4=%TYPE%4000-Vehicles
SET /A theme4_ok=0
SET theme_dir_name5=%TYPE%5000-Cities-Structures
SET /A theme5_ok=0
SET theme_dir_name6=%TYPE%6000-Sun
SET /A theme6_ok=0
SET theme_dir_name7=%TYPE%7000-Scenes
SET /A theme7_ok=0

REM Get the parent folder name
pushd..
set parent_folder=%cd%
popd


REM Check that the batch file is actualy in current folder
IF exist "%current_folder%\%batch_name%" (
      	SET /A batch_ok=1
) ELSE (
  	SET /A batch_ok=0
	ECHO The batch file does not appear to be in the parent Theme Directory.
	ECHO.
    	ECHO Please correct the problem.
        GOTO DONE
)

REM Check that all of the theme folders are in the current folder
set /A batch_ok=0
IF exist "%current_folder%\%theme_dir_name1%" (
	set /A theme1_ok=1
	set /A batch_ok=%batch_ok%+1 )

IF exist "%current_folder%\%theme_dir_name2%" (
	set /A theme2_ok=1
	set /A batch_ok=%batch_ok%+1 )


IF exist "%current_folder%\%theme_dir_name3%" (
	set /A theme3_ok=1
	set /A batch_ok=%batch_ok%+1 )


IF exist "%current_folder%\%theme_dir_name4%" (
	set /A theme4_ok=1
	set /A batch_ok=%batch_ok%+1 )


IF exist "%current_folder%\%theme_dir_name5%" (
	set /A theme5_ok=1
	set /A batch_ok=%batch_ok%+1 )


IF exist "%current_folder%\%theme_dir_name6%" (
	set /A theme6_ok=1
	set /A batch_ok=%batch_ok%+1 )


IF exist "%current_folder%\%theme_dir_name7%" (
	set /A theme7_ok=1
	set /A batch_ok=%batch_ok%+1 )


IF %batch_ok% NEQ 7 ( REM Something is missing
	ECHO.
	ECHO The folders containing the Theme Pictures are not in 
	ECHO %current_folder%
	ECHO.
	IF %theme1_ok% EQU 0 ECHO The folder %theme_dir_name1% is missing?
	IF %theme2_ok% EQU 0 ECHO The folder %theme_dir_name2% is missing?
	IF %theme3_ok% EQU 0 ECHO The folder %theme_dir_name3% is missing?
	IF %theme4_ok% EQU 0 ECHO The folder %theme_dir_name4% is missing?
	IF %theme5_ok% EQU 0 ECHO The folder %theme_dir_name5% is missing?
	IF %theme6_ok% EQU 0 ECHO The folder %theme_dir_name6% is missing?
	IF %theme7_ok% EQU 0 ECHO The folder %theme_dir_name7% is missing?
	ECHO.
    	ECHO Please correct the problem.
        GOTO DONE
)

REM See if we can figure out if if the parent folder is the users pictures folder
If NOT "%parent_folder%"=="%parent_folder:\Pictures=%" (
    SET pictures_dir=1
) else (
    SET pictures_dir=0
)

REM Create the name of the folder for the the Theme  
SET new_theme_folder=Theme_%filename%_%mydate%


ECHO.
ECHO   This Batch Process must be run in the directory that contains the Theme-Files which is
ECHO   currently SET to "(%current_folder%)"
IF /I %pictures_dir% EQU 1 (
      ECHO.
      ECHO   Parent Folder is Users Pictures Folder  "(%parent_folder%)" )
ECHO.
ECHO   If the above is not correct EXIT now!
ECHO.
SET /P create_theme=Create the theme file folder (%new_theme_folder%) (Y/[N])?
IF /I "%create_theme%" NEQ "Y" (
	ECHO.
	ECHO	   Theme folder not created
	GOTO DONE)

REM If files exists EXIT if not create file
ECHO.
IF exist %new_theme_folder% (
    ECHO The folder %new_theme_folder% already exists.  Batch file will EXIT.
    ECHO.
    ECHO Please correct the problem.
    ECHO.
    GOTO DONE
) else (
    ECHO Creating the Theme folder - - %new_theme_folder%
    mkdir %new_theme_folder%
    ECHO.
    PAUSE
)
REM Prompt for the directories to copy 
:COPY
IF %both% EQU X Echo Now we will add the Panoramic files.
ECHO.
ECHO.  Copy all %typename% theme files to %new_theme_folder% (Y) or (N) to prompt for individual folders?
ECHO.
SET /P copyall=Copy all %typename% files (Y/[N])?
IF /I "%copyall%" NEQ "Y" GOTO ASK

SET copypersonalpics=Y
SET copypersonalscenes=Y
SET copyanimal=Y
SET copyvehicles=Y
SET copycities=Y
SET copysun=Y
SET copyscenes=Y


GOTO COPY

:ASK
ECHO.
SET /P copypersonalpics=Copy the %typename% Personal Pictures files "(%theme_dir_name1%)" (Y/[N]) ?
ECHO.
SET /P copypersonalscenes=Copy the %typename% Personal Scenes files "(%theme_dir_name2%)" (Y/[N]) ?
ECHO.
SET /P copyanimal=Copy the %typename% Animal files "(%theme_dir_name3%)" (Y/[N]) ?
ECHO.
SET /P copyvehicles=Copy the %typename% Vehicles files "(%theme_dir_name4%)" (Y/[N]) ?
ECHO.
SET /P copycities=Copy the %typename% Cities-Structures files "(%theme_dir_name5%)" (Y/[N]) ?
ECHO.
SET /P copysun=Copy the %typename% Sun files "(%theme_dir_name6%)" (Y/[N]) ?
ECHO.
SET /P copyscenes=Copy the %typename% Scenes files "(%theme_dir_name7%)" (Y/[N]) ?
ECHO.

:COPY

REM Copy files as requested
IF /I "%copypersonalpics%" EQU "Y" (
	ECHO Copying %typename% Personal Pictures
	%copycmd% %type%1000-Personal-Pictures\*.jpg %new_theme_folder%\ /Y /Q)

IF /I "%copypersonalscenes%" EQU "Y" (
	ECHO Copying %typename% Personal Scenes
	%copycmd% %type%2000-Personal-Scenes\*.jpg %new_theme_folder%\ /Y /Q )

IF /I "%copyanimal%" EQU "Y" (
	ECHO Copying %typename% Animals
	%copycmd% %type%3000-Animals\*.jpg %new_theme_folder%\ /Y /Q )

IF /I "%copyvehicles%" EQU "Y" (
	ECHO Copying %typename% Vehicles
	%copycmd% %type%4000-Vehicles\*.jpg %new_theme_folder%\ /Y /Q )

IF /I "%copycities%" EQU "Y" (
	ECHO Copying %typename% Cities Structures
	%copycmd% %type%5000-Cities-Structures\*.jpg %new_theme_folder%\ /Y /Q )

IF /I "%copysun%" EQU "Y" (
	ECHO Copying %typename% Sun Related
	%copycmd% %type%6000-Sun\*.jpg %new_theme_folder%\ /Y /Q )

IF /I "%copyscenes%" EQU "Y" (
	ECHO Copying %typename% Scenes
	%copycmd% %type%7000-Scenes\*.jpg %new_theme_folder%\ /Y /Q )

rem Check to see if we are including all files (Both option)
IF %both% EQU B SET type=P& SET both=X& SET typename=Panoramic & GOTO COPY
REM       Note:      The P& is not a mistake as P & results in variable being set to Pspace	
ECHO.
ECHO    Creation of theme folder (%new_theme_folder%) complete.

REM Probably not in Pictures dir - just inform and exit.
ECHO.
IF /I %pictures_dir% EQU 0 (
	ECHO    The %new_theme_folder% should be MOVED to your Pictures Folder then
	ECHO    please follow the instructions in readme.txt for "Creating the Theme:"
	GOTO SETTINGS )

REM Check for existence of a previouse theme file with same name
IF /I %pictures_dir% EQU 1 (
      	IF exist %parent_folder%\%new_theme_folder% (
		ECHO Your %new_theme_folder% cannot be moved because 
    		ECHO The folder already exists in %parent_folder%
    		ECHO.
    		ECHO Please correct and move manually. then
		ECHO please follow the instructions in readme.txt for "Creating the Theme:"
		GOTO SETTINGS
	) else (
    		ECHO.
      		ECHO	Moving %new_theme_folder% to your Pictures Folder  "(%parent_folder%)"
		MOVE /Y %new_theme_folder% %parent_folder%
		ECHO.
		ECHO    Please follow the instructions in readme.txt for "Creating the Theme:" )
	)
:SETTINGS
ECHO.

IF %type% EQU x ECHO When selecting this Combined Theme/Slideshow SET Personalize/Background/Choose a fit to Fill & GOTO DONE
IF %type% EQU S ECHO When selecting this Standard Theme/Slideshow SET Personalize/Background/Choose a fit to Fill
IF %type% EQU P ECHO When selecting this Panoramic Theme/Slideshow SET Personalize/Background/Choose a fit to Span





:DONE
ECHO.
ECHO    Batch process complete.
ECHO.
PAUSE
:END